/********************************************************************************
 * Copyright (C) 2014 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>         *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/

#ifndef DETAILEDPROGRESSDIALOG_H
#define DETAILEDPROGRESSDIALOG_H

#include "ui_detailedprogressdialog.h"

#include <KDialog>
#include <KJob>
#include <KLocalizedString>
#include <KSqueezedTextLabel>
#include <QVBoxLayout>
#include <QProgressBar>
#include <QLabel>

class DetailedProgressDialog : public KDialog
{
    Q_OBJECT
    Q_DISABLE_COPY(DetailedProgressDialog)

public:
    explicit DetailedProgressDialog(const quint64&, const quint64&, QWidget*, Qt::WindowFlags flags = Qt::Dialog);

private:
    Ui::detailedprogressdialog detailedprogressdialog_ui;
    const quint64& completed_jobs;
    const quint64& total_jobs;
    QString job_title_text;

public slots:
    void update_progress_bars(KJob*, ulong);
    void update_job_description(KJob*, QString, QPair<QString, QString>, QPair<QString, QString>);
    void update_job_speed(KJob*, ulong);
};

#endif // DETAILEDPROGRESSDIALOG_H

