/********************************************************************************
 * Copyright (C) 2014 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>         *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/

#ifndef LOGGER_H
#define LOGGER_H

#include <KJob>
#include <KUrl>
#include <QFile>
#include <QTextStream>
#include <QWidget>

class Logger : public QObject
{
    Q_OBJECT
    Q_DISABLE_COPY(Logger)

public:
    explicit Logger(QWidget*, bool&);
    virtual ~Logger();
    void log_msg(const QString&);
    void log_start(const QString&, const KUrl&, const KUrl&);
    void log_cp(const KUrl&, const KUrl&);
    void log_ovwr(const KUrl&);
    void log_mv(const KUrl&, const KUrl&);
    void log_del(const KUrl&);
    void log_trash(const KUrl&);
    void log_end();

private:
    QTextStream log_text_stream;
    QFile log_file;

private slots:
    void log_job_info(KJob*, QString, QString);
};

#endif // LOGGER_H
