/********************************************************************************
 * Copyright (C) 2014 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>         *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/

#include "kfoldersync.h"

#include <KAboutData>
#include <KUniqueApplication>
#include <KCmdLineArgs>
#include <KLocale>
#include <KMessageBox>
#include <KUser>

int main(int argc, char** argv)
{
    KAboutData about("kfoldersync", NULL,
                     ki18n("KFolderSync"), "2.7.1",
                     ki18n("Folder synchronization and backup tool"),
                     KAboutData::License_GPL,
                     ki18n("(C) 2014 Lorenzo Porta (Vindex17)"),
                     ki18nc("@info", "Translations at: <link>https://www.transifex.com/projects/p/kfoldersync/</link>"),
                     "http://kde-apps.org/content/show.php/KFolderSync?content=164092");
    about.addAuthor(ki18n("Lorenzo Porta"), ki18n("Leading developer"), "vindex17@outlook.it", NULL, "Vindex17");
    KLocalizedString icon_helper_task = ki18n("He helped to design new icons");
    about.addCredit(ki18n("Paul Von Zimmerman"), icon_helper_task, "pcvonz@gmail.com", NULL, "pcvonz");
    about.addCredit(ki18n("Andreas Kainz"), icon_helper_task, "kainz.a@gmail.com", NULL, "andreaskai");
    KCmdLineArgs::init(argc, argv, &about);
    KUniqueApplication app;
    app.setWindowIcon(KIcon("kfoldersync"));

    // Check root privileges
    if (KUser().isSuperUser()) {
        QString warning_msg = i18nc("@info",
                                    "<warning>running <application>%1</application> with super user (root) privileges is discouraged!"
                                    "</warning><nl/><nl/>Are you absolutely sure about what you are doing?",
                                    app.applicationName());
        if (KMessageBox::warningYesNo(NULL, warning_msg) != KMessageBox::Yes)
            return EXIT_SUCCESS;
    }

    // Create the main window
    new KFolderSync;

    return app.exec();
}


