/********************************************************************************
 * Copyright (C) 2014 by Lorenzo Porta (Vindex17) <vindex17@outlook.it>         *
 *                                                                              *
 * This program is free software; you can redistribute it and/or                *
 * modify it under the terms of the GNU General Public License as               *
 * published by the Free Software Foundation; either version 2 of               *
 * the License or (at your option) version 3 or any later version               *
 * accepted by the membership of KDE e.V. (or its successor approved            *
 * by the membership of KDE e.V.), which shall act as a proxy                   *
 * defined in Section 14 of version 3 of the license.                           *
 *                                                                              *
 * This program is distributed in the hope that it will be useful,              *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                *
 * GNU General Public License for more details.                                 *
 *                                                                              *
 * You should have received a copy of the GNU General Public License            *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.        *
 *                                                                              *
 ********************************************************************************/

#ifndef REQUESTERWIDGET_H
#define REQUESTERWIDGET_H

#include "ui_requesterwidget.h"

class RequesterWidget : public QWidget
{
    Q_OBJECT
    Q_DISABLE_COPY(RequesterWidget)

public:
    explicit RequesterWidget(QWidget*, int);
    bool isReady();
    void set_index_pos(int);
    void set_button_enabled(bool);
    const KUrl source_kurl();
    const KUrl destination_kurl();

private:
    Ui::requesterwidget requesterwidget_ui;
    int index_pos;
    bool ready = false;
    KUrl src_dir_kurl, dest_dir_kurl;

    static const QString sameURL_error_msg();
    static const QString relationship_error_msg(const KUrl&, const KUrl&);
    bool are_related(const KUrl&, const KUrl&);

public slots:
    void clear_src();
    void clear_dest();

private slots:
    void set_src_dir_kurl(KUrl);
    void set_dest_dir_kurl(KUrl);
    void destroy();

signals:
    void destroyed(int);
    void ready_to_go();
};

#endif // REQUESTERWIDGET_H
